<?php
namespace Folha\Repositories;

class GpeEscalatrabm extends \Doctrine\ORM\EntityRepository
{

    public static function dataSetEsocial_S1050($dsordem, $limiteInferior, $limiteSuperior, $inicioPeriodo, $fimPeriodo, 
                                                $utilizaIntervaloDeDatas, $nrorg, $versaoHRM) 
    {
        $sql = "SELECT '__ID__' id,
                    'S-1050' versao,
                    '1' tpAmb,
                    '1' procEmi,
                    '1' indSegmento,
                    '$versaoHRM' verProc,
                    '__tpInscicaoEmpregador__' tpInscricao,
                    '__nrInscricaoEmpregador__' nrInscricao,
                    Eh.Nrescalatrabm codHorContratual,
                    to_char(Em.Dtinivigencia, 'MMYYYY') iniValidade,
                    '' fimValidade,
                    Eh.Prientrada horaEntrada,
                    Eh.Segsaida horaSaida,
                    Eh.Qthrescalatrabh durJornada,
                    '__tpJornada__' tpJornada,
                    -- Eh.Nmescalatrabh descTpJornada, -- Preenchido somente se tpJornada == 99
                    '__tpIntervalo__' tpIntervalo,
                    case when 24 * (to_date(Eh.Segentrada, 'HH24:MI') - to_date(Eh.Prisaida, 'HH24:MI')) < 0
                      then ROUND(60 * (24 * (to_date(Eh.Segentrada, 'HH24:MI') - to_date(Eh.Prisaida, 'HH24:MI')) + 24))
                      else ROUND(60 * (24 * (to_date(Eh.Segentrada, 'HH24:MI') - to_date(Eh.Prisaida, 'HH24:MI'))))
                    end durIntervalo,
                    to_char(to_date(Eh.Prisaida, 'HH24:MI'), 'HH24MI') inicioIntervalo,
                    to_char(to_date(Eh.Segentrada, 'HH24:MI'), 'HH24MI') terminoIntervalo,
                    '__varHorario__' varHorario, -- Este campo somente deverá existir caso hajam dados para um dos campos, entre deltaEntrada e deltaSaida.
                    '__deltaEntrada__' deltaEntrada,
                    '__deltaSaida__' deltaSaida,
                    1 inclusao,
                    0 alteracao,
                    1 novavalidade,
                    0 exclusao
                  from Gpe_Escalatrabm em
                  inner Join Gpe_Escalatrabh eh
                    on eh.Dtmescompetenc = (
                    SELECT max(Dtmescompetenc)
                      from Gpe_Escalatrabh
                      where Gpe_Escalatrabh.nrescalatrabm = eh.nrescalatrabm
                        and Gpe_Escalatrabh.nrorg         = eh.nrorg
                  )
                    and Eh.Nrescalatrabm= Em.Nrescalatrabm
                    and Eh.nrorg       = Em.nrorg
                  where Eh.nrorg = $nrorg
                    and WHERE_PLACEHOLDER";
        $where = "1=1";
        $sql = str_replace("WHERE_PLACEHOLDER", $where, $sql);

        // Esta linha está sendo utilizada somente para limitar o resultset utilizado para a aplicacao. Este deve ser
        // removido para a utilizacao dos sistema em produção.
        $sql = "SELECT teste.*, rownum from ($sql) teste where rownum < 10";
        $resultset = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        foreach ($resultset as &$row) {
            $row["_EVTTABHORCONTRATUAL_INFOHORCONTRATUAL_INCLUSAO_DADOSHORCONTRATUAL_HORARIOINTERVALO"] = array(
                "_EVTTABHORCONTRATUAL_INFOHORCONTRATUAL_INCLUSAO_DADOSHORCONTRATUAL_HORARIOINTERVALO_INICIOINTERVALO"  => $row["INICIOINTERVALO"], 
                "_EVTTABHORCONTRATUAL_INFOHORCONTRATUAL_INCLUSAO_DADOSHORCONTRATUAL_HORARIOINTERVALO_TERMINOINTERVALO" => $row["TERMINOINTERVALO"]
            );
        }

        return $resultset;
    }
    
    public static function retornaQtdeDiasTrabalhoPorVinc($dtcompetencia, $dtinicontagem, $diffDtFimDtIni, $nrorg, $nrvinculom){
            $sql = "
    SELECT
      COUNT(*) AS DIAS
    FROM GPE_ALTEESCALA AE
    /*Nome do Vinculo*/
    JOIN GPE_VINCULOM VM ON AE.NRVINCULOM = VM.NRVINCULOM
                         AND AE.NRORG = VM.NRORG
    /*Para filtro de Estrutura Legal e Gerencial*/
    JOIN GPE_VINCULOH VH ON VH.NRVINCULOM      = VM.NRVINCULOM
                         AND VH.NRORG          = VM.NRORG
                         AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH VHH
                                                  WHERE VHH.NRVINCULOM    = VH.NRVINCULOM
                                                    AND VHH.NRORG           = VH.NRORG
                                                    AND VHH.DTMESCOMPETENC <= :P_COMPETENCIA )
    
    /*Escala de Trabalho*/
    JOIN GPE_ESCALATRABH ETH ON ETH.NRORG         = AE.NRORG
                            AND ETH.NRESCALATRABM = AE.NRESCALATRABM
                            AND ETH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_ESCALATRABH
                                                       WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                         AND NRORG         = ETH.NRORG
                                                         AND NRESCALATRABM = ETH.NRESCALATRABM )
    /*Datas*/
    JOIN DATA DT ON DT.DTDATA BETWEEN TO_DATE( :P_DTINICONTAGEM ) AND  ( TO_DATE(:P_DTINICONTAGEM) + :P_QTDIAS )
    
    /*Turno e horários*/
    JOIN ( SELECT MAX(NRSEQHORARIO) NRSEQHORARIO, NRTURNO /*Adquiri o max do NRSEQHORARIO do turno em questão*/
           FROM GPE_HORARIOTURNO
           WHERE NRORG        = :P_NRORG
             AND IDATIVO      = 'S'
           GROUP BY NRTURNO ) AUX ON AUX.NRTURNO = AE.NRTURNO
    JOIN GPE_HORARIOTURNO HT ON HT.NRORG        = AE.NRORG
                            AND HT.NRTURNO      = AE.NRTURNO
                            AND HT.IDATIVO      = 'S'
                            AND HT.NRSEQHORARIO = NVL( NULLIF( MOD( TO_CHAR( DT.DTDATA - 4, 'J' ), AUX.NRSEQHORARIO ), 0 ), AUX.NRSEQHORARIO )
    JOIN GPE_HORDIAH HDH ON HDH.NRORG          = AE.NRORG 
                        AND HDH.NRHORDIAM      = HT.NRHORDIAM
                        AND HDH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                   WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                     AND NRORG     = HDH.NRORG 
                                                     AND NRHORDIAM = HDH.NRHORDIAM )
    /**/
    WHERE AE.NRORG       = :P_NRORG
      AND ( AE.NRVINCULOM  = :P_VINCULO OR :P_VINCULO IS NULL ) 
      AND HDH.IDTIPOHORARIO NOT IN ('F','C')
      AND AE.DTINIESCALA = ( SELECT MAX(DTINIESCALA) FROM GPE_ALTEESCALA
                             WHERE DTINIESCALA <= LAST_DAY(:P_COMPETENCIA)
                               AND NRORG                = AE.NRORG
                               AND NRVINCULOM   = AE.NRVINCULOM )
    
    ORDER BY AE.NRVINCULOM, DT.DTDATA
"
;

        $params = [
                "P_DTINICONTAGEM"  => $dtinicontagem,
                "P_QTDIAS"         => $diffDtFimDtIni,
                "P_NRORG"          => $nrorg,
                "P_VINCULO"        => $nrvinculom,  
                "P_COMPETENCIA"    => $dtcompetencia,
              ];
        
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);

        return $retorno[0]['DIAS'];              
              
    }
    
    public static function retornaQtdeDiasTrabalhoPorVincNova($dtcompetencia, $dtinicontagem, $diffDtFimDtIni, $nrorg, $nrvinculom, $valorReferencia = null){
        
        if(!$valorReferencia){
            $sql = "
    SELECT
      COUNT(*) AS DIAS
    FROM GPE_ALTEESCALA AE
    /*Nome do Vinculo*/
    JOIN GPE_VINCULOM VM ON AE.NRVINCULOM = VM.NRVINCULOM
                         AND AE.NRORG = VM.NRORG
    /*Para filtro de Estrutura Legal e Gerencial*/
    JOIN GPE_VINCULOH VH ON VH.NRVINCULOM      = VM.NRVINCULOM
                         AND VH.NRORG          = VM.NRORG
                         AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH VHH
                                                  WHERE VHH.NRVINCULOM    = VH.NRVINCULOM
                                                    AND VHH.NRORG           = VH.NRORG
                                                    AND VHH.DTMESCOMPETENC <= :P_COMPETENCIA )
    
    /*Escala de Trabalho*/
    JOIN GPE_ESCALATRABH ETH ON ETH.NRORG         = AE.NRORG
                            AND ETH.NRESCALATRABM = AE.NRESCALATRABM
                            AND ETH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_ESCALATRABH
                                                       WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                         AND NRORG         = ETH.NRORG
                                                         AND NRESCALATRABM = ETH.NRESCALATRABM )
    /*Datas*/
    JOIN DATA DT ON DT.DTDATA BETWEEN TO_DATE( :P_DTINICONTAGEM ) AND  ( TO_DATE(:P_DTINICONTAGEM) + :P_QTDIAS )
    
    /*Turno e horários*/
    JOIN ( SELECT MAX(NRSEQHORARIO) NRSEQHORARIO, NRTURNO /*Adquiri o max do NRSEQHORARIO do turno em questão*/
           FROM GPE_HORARIOTURNO
           WHERE NRORG        = :P_NRORG
             AND IDATIVO      = 'S'
           GROUP BY NRTURNO ) AUX ON AUX.NRTURNO = AE.NRTURNO
    JOIN GPE_HORARIOTURNO HT ON HT.NRORG        = AE.NRORG
                            AND HT.NRTURNO      = AE.NRTURNO
                            AND HT.IDATIVO      = 'S'
                            AND HT.NRSEQHORARIO = NVL( NULLIF( MOD( TO_CHAR( DT.DTDATA - 4, 'J' ), AUX.NRSEQHORARIO ), 0 ), AUX.NRSEQHORARIO )
    JOIN GPE_HORDIAH HDH ON HDH.NRORG          = AE.NRORG 
                        AND HDH.NRHORDIAM      = HT.NRHORDIAM
                        AND HDH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                   WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                     AND NRORG     = HDH.NRORG 
                                                     AND NRHORDIAM = HDH.NRHORDIAM )
    /**/
    WHERE AE.NRORG       = :P_NRORG
      AND ( AE.NRVINCULOM  = :P_VINCULO OR :P_VINCULO IS NULL ) 
      AND HDH.IDTIPOHORARIO NOT IN ('F','C')
      AND HDH.IDNGERABENEFDIARIO IN ('N')
      AND AE.DTINIESCALA = ( SELECT MAX(DTINIESCALA) FROM GPE_ALTEESCALA
                             WHERE DTINIESCALA <= LAST_DAY(:P_COMPETENCIA)
                               AND NRORG                = AE.NRORG
                               AND NRVINCULOM   = AE.NRVINCULOM )
    
    ORDER BY AE.NRVINCULOM, DT.DTDATA
"
;
        } else {
            $sql = "
    SELECT
      COUNT(*) AS DIAS
    FROM GPE_ALTEESCALA AE
    /*Nome do Vinculo*/
    JOIN GPE_VINCULOM VM ON AE.NRVINCULOM = VM.NRVINCULOM
                         AND AE.NRORG = VM.NRORG
    /*Para filtro de Estrutura Legal e Gerencial*/
    JOIN GPE_VINCULOH VH ON VH.NRVINCULOM      = VM.NRVINCULOM
                         AND VH.NRORG          = VM.NRORG
                         AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH VHH
                                                  WHERE VHH.NRVINCULOM    = VH.NRVINCULOM
                                                    AND VHH.NRORG           = VH.NRORG
                                                    AND VHH.DTMESCOMPETENC <= :P_COMPETENCIA )
    
    /*Escala de Trabalho*/
    JOIN GPE_ESCALATRABH ETH ON ETH.NRORG         = AE.NRORG
                            AND ETH.NRESCALATRABM = AE.NRESCALATRABM
                            AND ETH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_ESCALATRABH
                                                       WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                         AND NRORG         = ETH.NRORG
                                                         AND NRESCALATRABM = ETH.NRESCALATRABM )
    /*Datas*/
    JOIN DATA DT ON DT.DTDATA BETWEEN TO_DATE( :P_DTINICONTAGEM ) AND  ( TO_DATE(:P_DTINICONTAGEM) + :P_QTDIAS )
    
    /*Turno e horários*/
    JOIN ( SELECT MAX(NRSEQHORARIO) NRSEQHORARIO, NRTURNO /*Adquiri o max do NRSEQHORARIO do turno em questão*/
           FROM GPE_HORARIOTURNO
           WHERE NRORG        = :P_NRORG
             AND IDATIVO      = 'S'
           GROUP BY NRTURNO ) AUX ON AUX.NRTURNO = AE.NRTURNO
    JOIN GPE_HORARIOTURNO HT ON HT.NRORG        = AE.NRORG
                            AND HT.NRTURNO      = AE.NRTURNO
                            AND HT.IDATIVO      = 'S'
                            AND HT.NRSEQHORARIO = NVL( NULLIF( MOD( TO_CHAR( DT.DTDATA - 4, 'J' ), AUX.NRSEQHORARIO ), 0 ), AUX.NRSEQHORARIO )
    JOIN GPE_HORDIAH HDH ON HDH.NRORG          = AE.NRORG 
                        AND HDH.NRHORDIAM      = HT.NRHORDIAM
                        AND HDH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                   WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                     AND NRORG     = HDH.NRORG 
                                                     AND NRHORDIAM = HDH.NRHORDIAM )
    /**/
    WHERE AE.NRORG       = :P_NRORG
      AND ( AE.NRVINCULOM  = :P_VINCULO OR :P_VINCULO IS NULL ) 
      AND HDH.IDTIPOHORARIO NOT IN ('F','C')
      AND AE.DTINIESCALA = ( SELECT MAX(DTINIESCALA) FROM GPE_ALTEESCALA
                             WHERE DTINIESCALA <= LAST_DAY(:P_COMPETENCIA)
                               AND NRORG                = AE.NRORG
                               AND NRVINCULOM   = AE.NRVINCULOM )
    
    ORDER BY AE.NRVINCULOM, DT.DTDATA
"
;
        }
        

        $params = [
                "P_DTINICONTAGEM"  => $dtinicontagem,
                "P_QTDIAS"         => $diffDtFimDtIni,
                "P_NRORG"          => $nrorg,
                "P_VINCULO"        => $nrvinculom,  
                "P_COMPETENCIA"    => $dtcompetencia,
              ];
        
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);

        return $retorno[0]['DIAS'];              
              
    }
    
    public static function retornaQtdeDiasTrabalhoPorTurno($dtcompetencia, $dtinicontagem, $diffDtFimDtIni, $nrorg, $nrturno){
        $sql = "
SELECT
    COUNT(*) AS DIAS
  FROM (
        SELECT
              HT.*,
              ( SELECT MAX(NRSEQHORARIO) NRSEQHORARIO
                   FROM GPE_HORARIOTURNO
                   WHERE NRORG        = HT.NRORG
                     AND NRTURNO      = HT.NRTURNO
                     AND IDATIVO      = 'S') NRSEQHORARIO_MAX
            FROM GPE_HORARIOTURNO HT
            
            JOIN GPE_HORDIAH HDH ON HDH.NRORG          = HT.NRORG 
                                AND HDH.NRHORDIAM      = HT.NRHORDIAM
                                AND HDH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                           WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                             AND NRORG     = HDH.NRORG 
                                                             AND NRHORDIAM = HDH.NRHORDIAM )
                   
            /**/
            WHERE HT.NRORG        = :P_NRORG
              AND HT.NRTURNO      = :P_NRTURNO
              AND HT.IDATIVO      = 'S'
              AND HDH.IDTIPOHORARIO NOT IN ('F','C')
        ) HT
                                                             
  /*Datas*/
  JOIN DATA DT ON DT.DTDATA BETWEEN TO_DATE( :P_DTINICONTAGEM ) AND  ( TO_DATE(:P_DTINICONTAGEM) + :P_QTDIAS )
            
 WHERE HT.NRSEQHORARIO = NVL( NULLIF( MOD( TO_CHAR( DT.DTDATA - 4, 'J' ), HT.NRSEQHORARIO_MAX ), 0 ), HT.NRSEQHORARIO_MAX )
"
;

        $params = [
                "P_DTINICONTAGEM"  => $dtinicontagem,
                "P_QTDIAS"         => $diffDtFimDtIni,
                "P_NRORG"          => $nrorg,
                "P_NRTURNO"        => $nrturno,  
                "P_COMPETENCIA"    => $dtcompetencia,
              ];
        
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);

        return $retorno[0]['DIAS'];              
              
    }
    
    public static function retornaDiasFolga($dtcompetencia, $dtinicontagem, $diffDtFimDtIni, $nrorg, $nrturno){
        $sql = "
SELECT
    COUNT(*) AS DIAS
  FROM (
        SELECT
              HT.*,
              ( SELECT MAX(NRSEQHORARIO) NRSEQHORARIO
                   FROM GPE_HORARIOTURNO
                   WHERE NRORG        = HT.NRORG
                     AND NRTURNO      = HT.NRTURNO
                     AND IDATIVO      = 'S') NRSEQHORARIO_MAX
            FROM GPE_HORARIOTURNO HT
            
            JOIN GPE_HORDIAH HDH ON HDH.NRORG          = HT.NRORG 
                                AND HDH.NRHORDIAM      = HT.NRHORDIAM
                                AND HDH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                           WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                             AND NRORG     = HDH.NRORG 
                                                             AND NRHORDIAM = HDH.NRHORDIAM )
                   
            /**/
            WHERE HT.NRORG        = :P_NRORG
              AND HT.NRTURNO      = :P_NRTURNO
              AND HT.IDATIVO      = 'S'
              AND HDH.IDTIPOHORARIO IN ('F','C')
        ) HT
                                                             
  /*Datas*/
  JOIN DATA DT ON DT.DTDATA BETWEEN TO_DATE( :P_DTINICONTAGEM ) AND  ( TO_DATE(:P_DTINICONTAGEM) + :P_QTDIAS )
            
 WHERE HT.NRSEQHORARIO = NVL( NULLIF( MOD( TO_CHAR( DT.DTDATA - 4, 'J' ), HT.NRSEQHORARIO_MAX ), 0 ), HT.NRSEQHORARIO_MAX )
"
;

        $params = [
                "P_DTINICONTAGEM"  => $dtinicontagem,
                "P_QTDIAS"         => $diffDtFimDtIni,
                "P_NRORG"          => $nrorg,
                "P_NRTURNO"        => $nrturno,  
                "P_COMPETENCIA"    => $dtcompetencia,
              ];
        
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);

        return $retorno[0]['DIAS'];              
              
    }
    
    public static function retornaDiasFolgaVinc($dtcompetencia, $dtinicontagem, $diffDtFimDtIni, $nrorg, $nrvinculom, $idngerabenefdiario = 'N'){
        $sql = "
    SELECT TO_CHAR(DT.DTDATA, 'DD/MM/YYYY') AS DTDATA
      FROM DATA DT
     WHERE DT.DTDATA BETWEEN :P_DTINICONTAGEM AND ( TO_DATE(:P_DTINICONTAGEM) + :P_QTDIAS )
    MINUS 
    SELECT
          TO_CHAR(DT.DTDATA, 'DD/MM/YYYY') AS DTDATA
        FROM GPE_ALTEESCALA AE
        /*Nome do Vinculo*/
        JOIN GPE_VINCULOM VM ON AE.NRVINCULOM = VM.NRVINCULOM
                             AND AE.NRORG = VM.NRORG
        /*Para filtro de Estrutura Legal e Gerencial*/
        JOIN GPE_VINCULOH VH ON VH.NRVINCULOM      = VM.NRVINCULOM
                             AND VH.NRORG          = VM.NRORG
                             AND VH.DTMESCOMPETENC = (SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH VHH
                                                      WHERE VHH.NRVINCULOM    = VH.NRVINCULOM
                                                        AND VHH.NRORG           = VH.NRORG
                                                        AND VHH.DTMESCOMPETENC <= :P_COMPETENCIA )
        
        /*Escala de Trabalho*/
        JOIN GPE_ESCALATRABH ETH ON ETH.NRORG         = AE.NRORG
                                AND ETH.NRESCALATRABM = AE.NRESCALATRABM
                                AND ETH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_ESCALATRABH
                                                           WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                             AND NRORG         = ETH.NRORG
                                                             AND NRESCALATRABM = ETH.NRESCALATRABM )
        /*Datas*/
        JOIN DATA DT ON DT.DTDATA BETWEEN TO_DATE( :P_DTINICONTAGEM ) AND  ( TO_DATE(:P_DTINICONTAGEM) + :P_QTDIAS )
        
        /*Turno e horários*/
        JOIN ( SELECT MAX(NRSEQHORARIO) NRSEQHORARIO, NRTURNO /*Adquiri o max do NRSEQHORARIO do turno em questão*/
               FROM GPE_HORARIOTURNO
               WHERE NRORG        = :P_NRORG
                 AND IDATIVO      = 'S'
               GROUP BY NRTURNO ) AUX ON AUX.NRTURNO = AE.NRTURNO
        JOIN GPE_HORARIOTURNO HT ON HT.NRORG        = AE.NRORG
                                AND HT.NRTURNO      = AE.NRTURNO
                                AND HT.IDATIVO      = 'S'
                                AND HT.NRSEQHORARIO = NVL( NULLIF( MOD( TO_CHAR( DT.DTDATA - 4, 'J' ), AUX.NRSEQHORARIO ), 0 ), AUX.NRSEQHORARIO )
        JOIN GPE_HORDIAH HDH ON HDH.NRORG          = AE.NRORG 
                            AND HDH.NRHORDIAM      = HT.NRHORDIAM
                            AND HDH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                       WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                         AND NRORG     = HDH.NRORG 
                                                         AND NRHORDIAM = HDH.NRHORDIAM )
        /**/
        WHERE AE.NRORG       = :P_NRORG
          AND ( AE.NRVINCULOM  = :P_VINCULO OR :P_VINCULO IS NULL ) 
          AND HDH.IDTIPOHORARIO NOT IN ('F','C')
          AND (:P_IDNGERABENEFDIARIO != 'S' OR HDH.IDNGERABENEFDIARIO != 'S')
          AND AE.DTINIESCALA = ( SELECT MAX(DTINIESCALA) FROM GPE_ALTEESCALA
                                 WHERE DTINIESCALA <= LAST_DAY(:P_COMPETENCIA)
                                   AND NRORG                = AE.NRORG
                                   AND NRVINCULOM   = AE.NRVINCULOM )
"
;

        $params = [
                "P_DTINICONTAGEM"           => $dtinicontagem,
                "P_QTDIAS"                  => $diffDtFimDtIni,
                "P_NRORG"                   => $nrorg,
                "P_VINCULO"                 => $nrvinculom,  
                "P_COMPETENCIA"             => $dtcompetencia,
                "P_IDNGERABENEFDIARIO"      => $idngerabenefdiario,
              ];
        
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);

        return $retorno;              
              
    }
    
    public static function retornaDiasFolgaTurno($dtcompetencia, $dtinicontagem, $diffDtFimDtIni, $nrorg, $nrturno){
        $sql = "
SELECT TO_CHAR(DT.DTDATA, 'DD/MM/YYYY') AS DTDATA
  FROM DATA DT
 WHERE DT.DTDATA BETWEEN :P_DTINICONTAGEM AND ( TO_DATE(:P_DTINICONTAGEM) + :P_QTDIAS )
MINUS 
SELECT
    TO_CHAR(DT.DTDATA, 'DD/MM/YYYY') AS DTDATA
  FROM (
        SELECT
              HT.*,
              ( SELECT MAX(NRSEQHORARIO) NRSEQHORARIO
                   FROM GPE_HORARIOTURNO
                   WHERE NRORG        = HT.NRORG
                     AND NRTURNO      = HT.NRTURNO
                     AND IDATIVO      = 'S') NRSEQHORARIO_MAX
            FROM GPE_HORARIOTURNO HT
            
            JOIN GPE_HORDIAH HDH ON HDH.NRORG          = HT.NRORG 
                                AND HDH.NRHORDIAM      = HT.NRHORDIAM
                                AND HDH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_HORDIAH
                                                           WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                             AND NRORG     = HDH.NRORG 
                                                             AND NRHORDIAM = HDH.NRHORDIAM )
                   
            /**/
            WHERE HT.NRORG        = :P_NRORG
              AND HT.NRTURNO      = :P_NRTURNO
              AND HT.IDATIVO      = 'S'
              AND HDH.IDTIPOHORARIO NOT IN ('F','C')
        ) HT
                                                             
  /*Datas*/
  JOIN DATA DT ON DT.DTDATA BETWEEN TO_DATE( :P_DTINICONTAGEM ) AND  ( TO_DATE(:P_DTINICONTAGEM) + :P_QTDIAS )
            
 WHERE HT.NRSEQHORARIO = NVL( NULLIF( MOD( TO_CHAR( DT.DTDATA - 4, 'J' ), HT.NRSEQHORARIO_MAX ), 0 ), HT.NRSEQHORARIO_MAX )
"
;

        $params = [
                "P_DTINICONTAGEM"  => $dtinicontagem,
                "P_QTDIAS"         => $diffDtFimDtIni,
                "P_NRORG"          => $nrorg,
                "P_NRTURNO"        => $nrturno,  
                "P_COMPETENCIA"    => $dtcompetencia,
              ];
        
        $retorno = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);

        return $retorno;              
              
    }
    
    
    public static function _retornaHistórico($nrescalatrabh, $nrorg){
        $sql = "SELECT * FROM GPE_ESCALATRABH
                WHERE NRESCALATRABH = :P_NRESCALATRABH AND NRORG = :P_NRORG
                ";
        
        $params = ["P_NRESCALATRABH"=>$nrescalatrabh, "P_NRORG"=>$nrorg];
        $result = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->fetchAll($sql, $params);

        if(isset($result[0]))return $result[0];
        else return null;
    }
    
    
}