/* Sistemas Integrados TECNISA

Nome: 0330_PLATRGS.SQL

 Descrio:
 ###########################################################################################
 #             Triggers para atualizao do campo DTULTATURECE da tabela PRATO             #
 ###########################################################################################

Criao:
   05/03/2004 Leonardo Leo de Assis
*/

IF EXISTS(SELECT
             *
          FROM
             SYSOBJECTS O,
             SYSUSERS U
          WHERE
             O.NAME = 'DTULTATU_RECEPADR' AND
             TYPE   = 'TR'                AND
             U.UID  = O.UID               AND
             U.NAME = USER)
  DROP TRIGGER DTULTATU_RECEPADR
  GO

CREATE TRIGGER DTULTATU_RECEPADR
ON
   RECEPADR
FOR INSERT, UPDATE, DELETE

AS
BEGIN
  UPDATE
     PRATO
  SET
     DTULTATURECE = GETDATE()
  FROM
     INSERTED
  WHERE
     PRATO.CDPRATO = INSERTED.CDPRATO AND
     PRATO.CDFILAUXPRAT = INSERTED.CDFILAUXPRAT;
  IF @@ROWCOUNT = 0
  BEGIN
     UPDATE
        PRATO
     SET
        DTULTATURECE = GETDATE()
     FROM
        DELETED
     WHERE
        PRATO.CDPRATO = DELETED.CDPRATO AND
        PRATO.CDFILAUXPRAT = DELETED.CDFILAUXPRAT;
  END;
  IF (0 <> (SELECT COUNT(*) FROM DELETED)) BEGIN /* UPDATE */
     UPDATE
        RECEPADR
     SET DTULTATURECP = GETDATE()
     FROM
        INSERTED, DELETED
     WHERE
        RECEPADR.CDFILAUXPRAT = INSERTED.CDFILAUXPRAT AND
        RECEPADR.CDPRATO      = INSERTED.CDPRATO      AND
        RECEPADR.CDPRODUTO    = INSERTED.CDPRODUTO    AND
        RECEPADR.CDFILAUXPRAT = DELETED.CDFILAUXPRAT  AND
        RECEPADR.CDPRATO      = DELETED.CDPRATO       AND
        RECEPADR.CDPRODUTO    = DELETED.CDPRODUTO;
  END ELSE BEGIN  /* INSERT */
     UPDATE
        RECEPADR
     SET DTULTATURECP = GETDATE()
     FROM
        INSERTED
     WHERE
        RECEPADR.CDFILAUXPRAT = INSERTED.CDFILAUXPRAT AND
        RECEPADR.CDPRATO      = INSERTED.CDPRATO      AND
        RECEPADR.CDPRODUTO    = INSERTED.CDPRODUTO;
  END;
END;
GO