package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class EmissaoCardapioSemanaPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaEmissaoCarpioSemana = By.xpath("//span[text() = 'Emissão do Cardápio da Semana']");

    By campoRelatorio = By.xpath("//div[@class='zh-select-native-div']/div[2]");
    By relatorioSemanaAlergenico = By.xpath("//div[@class='zh-select-native-div']//li[text() = 'Emissão de Cardápio da Semana - Alergênico']");
    By relatorioCardapioSemana = By.xpath("//div[@class='zh-select-native-div']//li[text() = 'Emissão do Cardápio da Semana']");
    By relatorioCardapioCusto = By.xpath("//div[@class='zh-select-native-div']//li[text() = 'Emissão de Cardápio da Semana (Custo)']");

    By botaoCampoUnidade = By.xpath("//div[@id=\"NMFILIAL\"]//span[@style=\"background-image: none; display: block;\"]");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoBc129 = By.xpath("//div[@data-zh-id=\"13767247994127411761243\"]//span[text() = '9999 | DEPOSITO BC 129']");

    By semanaInicial = By.id("SEMANAINICIAL");
    By botaoCampoSemanaInicial = By.xpath("//div[@data-zh-id=\"13767247992940326966254\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoMenusSemanaInicial = By.xpath("//div[@data-zh-id=\"13767247991114054680252\"]//button[@class=\"spin-button spin-button-minus\"]");
    By botaoMaisSemanaInicial = By.xpath("//div[@data-zh-id=\"13767247991114054680252\"]//button[@class=\"spin-button spin-button-plus\"]");
    By numeroSemanaInicial = By.id("NRSEMANAINI");

    By botaoCampoSemanaFinal = By.xpath("//div[@data-zh-id=\"13767247992831040250258\"]//span[@style=\"background-image: none; display: block;\"]");
    By semanaFinal = By.id("SEMANAFINAL");
    By botaoMenusSemanaFinal = By.xpath("//div[@data-zh-id=\"13767247991222791771256\"]//button[@class=\"spin-button spin-button-minus\"]");
    By botaoMaisSemanaFinal = By.xpath("//div[@data-zh-id=\"13767247991222791771256\"]//button[@class=\"spin-button spin-button-plus\"]");
    By numeroSemanaFinal = By.id("NRSEMANAFIN");

    By todosServicos = By.xpath("//div[@data-zh-id='13767247992176345398250']//div[@class='zh-box mousetrap zh-ripple-effect']");
    By campoServico = By.id("NMSERVICO");
    By servicoSolicitacao = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'SOLICITACAO']");
    By servicoDistribuicao = By.xpath("//div[@data-zh-field-name='NMSERVICO']//span[text() = 'DISTRIBUICAO']");

    By todosDiasSemana = By.xpath("//div[@data-zh-id='1376724799282993180671']//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoDiasSemana = By.id("WEEK_DAYS");
    By diaDomingo = By.xpath("//div[@data-zh-field-name='DESCRIPTION']//span[text() = 'Domingo']");
    By diaSegundaFeira = By.xpath("//div[@data-zh-field-name='DESCRIPTION']//span[text() = 'Segunda-Feira']");

    By botaoOk = By.xpath("//section[@class='popup-container']//div[@class='zh-footer-right']//span[text() = 'Ok']");

    By comensaisNaoImprimir = By.xpath("//label[@for=\"radio-IMPCOMENSAIS-N\"]//div[@class=\"zh-inner-circle\"]");
    By comensaisNumero = By.xpath("//label[@for=\"radio-IMPCOMENSAIS-NUMERO\"]//div[@class=\"zh-inner-circle\"]");
    By comensaisPercentual = By.xpath("//label[@for=\"radio-IMPCOMENSAIS-PERCENTUAL\"]//div[@class=\"zh-inner-circle\"]");
    By radioButtonComensaisNaoImprimir = By.id("radio-IMPCOMENSAIS-N");
    By radioButtonComensaisNumero = By.id("radio-IMPCOMENSAIS-NUMERO");
    By radioButtonComensaisPercentual = By.id("radio-IMPCOMENSAIS-PERCENTUAL");

    By agruparPorSemana = By.xpath("//label[@for=\"radio-AGRUPAR-SEMANA\"]//div[@class=\"zh-inner-circle\"]");
    By radioButtonAgruparPorSemana = By.id("radio-AGRUPAR-SEMANA");
    By agruparPorServico = By.xpath("//label[@for=\"radio-AGRUPAR-SERVICO\"]//div[@class=\"zh-inner-circle\"]");
    By radioButtonAgruparPorServico = By.id("radio-AGRUPAR-SERVICO");

    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"13767247994127411761243\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"1376724799108472373246\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioSemanaInicial = By.xpath("//div[@data-zh-id=\"13767247992940326966254\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioSemanaFinal = By.xpath("//div[@data-zh-id=\"13767247992831040250258\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioImprimirDiasSemana = By.xpath("//div[@data-zh-id=\"137672479951145371670\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioTipoCusto = By.xpath("//div[@data-zh-id=\"13767247994007212137266\"]//div[@class=\"zh-validation\"]/span");

    By imprimirMensagem = By.xpath("//label[@for=\"zh-checkbox-IMPMENSAGEM\"]");
    By imprimirNomeFantasia = By.xpath("//label[@for=\"zh-checkbox-IMPNMFANTASIA\"]");
    By quebraDePagina = By.xpath("//label[@for=\"zh-checkbox-QUEBRARPAG\"]");
    By quebraPorMes = By.xpath("//label[@for=\"zh-checkbox-QUEBRAMES\"]");
    By checkBoxImprimirMensagem = By.id("zh-checkbox-IMPMENSAGEM");
    By checkBoxImprimirNomeFantasia = By.id("zh-checkbox-IMPNMFANTASIA");
    By checkBoxQuebraDePagina = By.id("zh-checkbox-QUEBRARPAG");
    By checkBoxQuebraPorMes = By.id("zh-checkbox-QUEBRAMES");

    By botaoCampoTipoCusto = By.xpath("//div[@id=\"NMTIPOCUSTO\"]//span[@style=\"background-image: none; display: block;\"]");
    //para verificar se o campo tipo de custo está habilitado
    By campoTipoCustoImput = By.xpath("//div[@id=\"NMTIPOCUSTO\"]/input");

    By campoTipoCusto = By.id("NMTIPOCUSTO");
    By calculoCustoReferencia = By.xpath("//div[@data-zh-id=\"13767247994142796452267\"]//label[@for=\"radio-TPDATA-0\"]//div[@data-zh-contenteditable=\"true\"]");
    By calculoCustoCardapio = By.xpath("//div[@data-zh-id=\"13767247994142796452267\"]//label[@for=\"radio-TPDATA-1\"]//div[@data-zh-contenteditable=\"true\"]");
    By radioButtonCalculoCustoReferencia = By.id("radio-TPDATA-0");
    By radioButtonCalculoCustoCardapio = By.id("radio-TPDATA-1");

    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@contenteditable='true']");
    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//span[text() = 'Confirmar']");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        tempo();
        click(botaoMenu);
        sendKeys(campoPesquisar, "Emissão do Cardápio da Semana");
        click(telaEmissaoCarpioSemana);
    }

    public void selecionaRelatorio(String nomeDoRelatorio) {
        if(nomeDoRelatorio == "Emissão de Cardápio da Semana - Alergênico") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioSemanaAlergenico);
        } else if(nomeDoRelatorio == "Emissão do Cardápio da Semana") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioSemana);
        } else if(nomeDoRelatorio == "Emissão de Cardápio da Semana (Custo)") {
            clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioCusto);
        }
    }

    public void selecionarServico() {
        click(todosServicos);
        click(campoServico);
        click(servicoSolicitacao);
        click(servicoDistribuicao);
        click(botaoOk);
    }

    public void selecionarDias() {
        click(todosDiasSemana);
        click(todosDiasSemana);
        click(campoDiasSemana);
        click(diaDomingo);
        click(diaSegundaFeira);
        click(botaoOk);
    }

    public void selecionarAgruparPorServico() {
        click(agruparPorServico);
    }

    public void selecionarBaseCardapio() {
        click(calculoCustoCardapio);
    }

    public void selecionarComensal(String nomeComensal) {
        if (nomeComensal == "Não imprimir") {
            click(comensaisNaoImprimir);
        } else if (nomeComensal == "Número") {
            click(comensaisNumero);
        } else if (nomeComensal == "Percentual") {
            click(comensaisPercentual);
        }
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

    public void camposObrigatorios() {
        click(botaoCampoUnidade);
        click(todosServicos);
        click(botaoCampoSemanaInicial);
        click(botaoCampoSemanaFinal);
        click(todosDiasSemana);
        click(todosDiasSemana);

        click(botaoRelatorio);

        //mensagens encontradas nos campos obrigatórios
        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String semanaInicial = getText(mensagemObrigatorioSemanaInicial);
        String semanaFinal = getText(mensagemObrigatorioSemanaFinal);
        String imprimirDiasSemana = getText(mensagemObrigatorioImprimirDiasSemana);


        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(unidade, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo unidade");
        Assert.assertEquals(servico, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo serviço");
        Assert.assertEquals(semanaInicial, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo semana inicial");
        Assert.assertEquals(semanaFinal, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo semana final");
        Assert.assertEquals(imprimirDiasSemana, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo imprimir dias da semana");

        clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioCusto);
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 500)");
        click(botaoCampoTipoCusto);
        click(botaoRelatorio);
        String tipoCusto = getText(mensagemObrigatorioTipoCusto);
        Assert.assertEquals(tipoCusto, mensagemEsperada, "Verificação da mensagem de campo obrigatório do campo tipo custo");
    }

    public void semanaInicialFinal() {
        tempo();
        clearAndSendKeys(numeroSemanaInicial, "9");
        clearAndSendKeys(numeroSemanaFinal, "11");
        click(semanaInicial);

        conferirDatas("27/02/2023", "19/03/2023", 9, 11);

        String valorNumSemanaInicial = "";
        String valorNumSemanaFinal = "";

        click(botaoMenusSemanaInicial);
        valorNumSemanaInicial = driver.findElement(numeroSemanaInicial).getAttribute("value");
        Assert.assertEquals(valorNumSemanaInicial, "8", "Verificação do valor da semana inicial, após clicar no botão menus '-'");
        conferirDatas("20/02/2023", "19/03/2023", 8, 11);

        click(botaoMaisSemanaInicial);
        valorNumSemanaInicial = driver.findElement(numeroSemanaInicial).getAttribute("value");
        Assert.assertEquals(valorNumSemanaInicial, "9", "Verificação do valor da semana inicial, após clicar no botão mais '+'");
        conferirDatas("27/02/2023", "19/03/2023", 9, 11);

        click(botaoMenusSemanaFinal);
        valorNumSemanaFinal = driver.findElement(numeroSemanaFinal).getAttribute("value");
        Assert.assertEquals(valorNumSemanaFinal, "10", "Verificação do valor da semana final, após clicar no botão menus '-'");
        conferirDatas("27/02/2023", "12/03/2023", 9, 10);

        click(botaoMaisSemanaFinal);
        valorNumSemanaFinal = driver.findElement(numeroSemanaFinal).getAttribute("value");
        Assert.assertEquals(valorNumSemanaFinal, "11", "Verificação do valor da semana final, após clicar no botão mais '+'");
        conferirDatas("27/02/2023", "19/03/2023", 9, 11);
    }

    private void conferirDatas(String expDataSemanaInicial, String expDataSemanaFinal, int numeroSemanaInicial, int numeroSemanaFinal) {
        //datas encontradas
        String encDataSemanaInicial = driver.findElement(semanaInicial).getAttribute("value");
        String encDataSemanaFinal = driver.findElement(semanaFinal).getAttribute("value");

        Assert.assertEquals(encDataSemanaInicial, expDataSemanaInicial, "Verificação data semana inicial, após alterar o valor do número da semana inicial para " + numeroSemanaInicial);
        Assert.assertEquals(encDataSemanaFinal, expDataSemanaFinal, "Verificação data semana final, após alterar o valor do número da semana final para " + numeroSemanaFinal);
    }

    public void camposTipoCustoHabilitosPelosRelatorios() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioSemana);
        verificarCamposTipoCusto(false, "Emissão do Cardápio da Semana");
        clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioCusto);
        verificarCamposTipoCusto(true, "Emissão de Cardápio da Semana (Custo)");
        clicarCampoSelecionarValor(campoRelatorio, relatorioSemanaAlergenico);
        verificarCamposTipoCusto(false, "Emissão de Cardápio da Semana - Alergênico");
    }

    private void verificarCamposTipoCusto(boolean estaHabilitado, String relatorio) {
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 500)");
        boolean tipoCusto = returnIfElementIsEnabled(campoTipoCustoImput);
        boolean referencia = returnIfElementIsEnabled(radioButtonCalculoCustoReferencia);
        boolean cardapio = returnIfElementIsEnabled(radioButtonCalculoCustoCardapio);

        Assert.assertEquals(tipoCusto, estaHabilitado, "Verificando se o campo tipo custo está habilitado durante o relatório " + relatorio);
        Assert.assertEquals(referencia, estaHabilitado, "Verificando se o radio button referência está habilitado durante o relatório " + relatorio);
        Assert.assertEquals(cardapio, estaHabilitado, "Verificando se o radio button referência está habilitado durante o relatório " + relatorio);
        refresh();
    }

    public void verificarBotoesComensais() {
        click(comensaisNaoImprimir);
        boolean naoImprimir = returnIfElementIsSelected(radioButtonComensaisNaoImprimir);
        Assert.assertEquals(naoImprimir, true, "Verificação se após clicar na opção 'Não Imprimir' das comensais, de fato a opção fica selecionada");

        click(comensaisNumero);
        boolean numero = returnIfElementIsSelected(radioButtonComensaisNumero);
        Assert.assertEquals(numero, true, "Verificação se após clicar na opção 'Número' das comensais, de fato a opção fica selecionada");

        click(comensaisPercentual);
        boolean percentual = returnIfElementIsSelected(radioButtonComensaisPercentual);
        Assert.assertEquals(percentual, true, "Verificação se após clicar na opção 'Percentual' das comensais, de fato a opção fica selecionada");
    }

    public void verificarBotoesAgruparPor() {
        click(agruparPorSemana);
        boolean semana = returnIfElementIsSelected(radioButtonAgruparPorSemana);
        Assert.assertEquals(semana, true, "Verificar se após clicar na opção 'Semana' em agrupar por, de fato a opção está sendo selecionada");

        click(agruparPorServico);
        boolean servico = returnIfElementIsSelected(radioButtonAgruparPorServico);
        Assert.assertEquals(servico, true, "Verificar se após clicar na opção 'Servico' em agrupar por, de fato a opção está sendo selecionada");
    }

    public void verificarBotoesCalcularCustoPlanejado() {
        clicarCampoSelecionarValor(campoRelatorio, relatorioCardapioCusto);
        tempo();
        javaScriptExecutor.executeScript("document.querySelector(\"body > span > section > section > div.default-window > section.everything > div > section > section > div\").scrollBy(0, 500)");

        click(calculoCustoReferencia);
        boolean referencia = returnIfElementIsSelected(radioButtonCalculoCustoReferencia);
        Assert.assertEquals(referencia, true, "Verificar se após clicar na opção 'de Referência' cálcular custo planejado com base na data, de fato a opção está sendo selecionada");

        click(calculoCustoCardapio);
        boolean cardapio = returnIfElementIsSelected(radioButtonCalculoCustoCardapio);
        Assert.assertEquals(cardapio, true, "Verificar se após clicar na opção 'de Cardápio' cálcular custo planejado com base na data, de fato a opção está sendo selecionada");
    }

    public void verificarOpcoesCheckBox() {
        boolean checkImprimirMensagem = returnIfElementIsSelected(checkBoxImprimirMensagem);
        Assert.assertEquals(checkImprimirMensagem, false, "Verificar se assim que a tela carrega o check-box de 'imprimir mensagem' está desmarcado");
        click(imprimirMensagem);
        checkImprimirMensagem = returnIfElementIsSelected(checkBoxImprimirMensagem);
        Assert.assertEquals(checkImprimirMensagem, true, "Verificar se clicar em 'imprimir mensagem' a opção fica marcada");

        boolean checkImprimirNome = returnIfElementIsSelected(checkBoxImprimirNomeFantasia);
        Assert.assertEquals(checkImprimirNome, false, "Verificar se assim que a tela carrega o check-box de 'imprimir nome fantasia' está desmarcado");
        click(imprimirNomeFantasia);
        checkImprimirNome = returnIfElementIsSelected(checkBoxImprimirNomeFantasia);
        Assert.assertEquals(checkImprimirNome, true, "Verificar se clicar em 'imprimir nome fantasia' a opção fica marcada");

        boolean checkQuebraDePagina = returnIfElementIsSelected(checkBoxQuebraDePagina);
        Assert.assertEquals(checkQuebraDePagina, true, "Verificar se assim que a tela carrega o check-box de 'quebra de página' está marcado");
        click(quebraDePagina);
        checkQuebraDePagina = returnIfElementIsSelected(checkBoxQuebraDePagina);
        Assert.assertEquals(checkQuebraDePagina, false, "Verificar se clicar em 'quebra de página' a opção fica desmarcada");

        boolean checkQuebraPorMes = returnIfElementIsSelected(checkBoxQuebraPorMes);
        Assert.assertEquals(checkQuebraPorMes, true, "Verificar se assim que a tela carrega o check-box de 'quebra por mês' está marcado");
        click(quebraPorMes);
        checkQuebraPorMes = returnIfElementIsSelected(checkBoxQuebraPorMes);
        Assert.assertEquals(checkQuebraPorMes, false, "Verificar se clicar em 'quebra por mês' a opção fica desmarcada");
    }

}
