package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

public class RelacaoPratoXEmbalagemPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By opcaoTelaRelacaoPratoXEmbalagem = By.xpath("//span[text() = 'Relação Prato x Embalagem']");

    By abaEmbalagemPorPrato = By.xpath("//section[@data-zh-id=\"101216688014657655813099\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Embalagem por Prato']");
    By abaPratoPorEmbalagem = By.xpath("//section[@data-zh-id=\"101216688014657655813099\"]//div[@class=\"zh-tab-scroller\"]//a[text() = 'Prato por Embalagem']");

    By tortaDeChocolate = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'TORTA DE CHOCOLATE']");
    By pratoFeijoadaTransportada = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'FEIJOADA TRANSPORTADA']");
    By botaoCampoEmbalagem = By.xpath("//div[@id=\"NMCONTAINER\"]//span[@style=\"background-image: none; display: block;\"]");
    By embalagemPanela = By.xpath("//div[@id=\"grid-9000\"]//span[text() = 'PANELA']");
    By embalagemMarmitex = By.xpath("//div[@id=\"grid-9000\"]//span[text() = 'MARMITÉX']");
    By campoQuantidade = By.id("VRQTDEPRATEMB");

    By checkBoxEmabalagem = By.xpath("//div[@id=\"grid-101216688024018271243125\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]");
    By codigoEmbalagem = By.xpath("//div[@id=\"grid-101216688024018271243125\"]//div[@class=\"body-content\"]/div[1]//div[2]/span");
    By nomeEmbalagem = By.xpath("//div[@id=\"grid-101216688024018271243125\"]//div[@class=\"body-content\"]/div[1]//div[3]/span");
    By quantidadeEmbalagem = By.xpath("//div[@id=\"grid-101216688024018271243125\"]//div[@class=\"body-content\"]/div[1]//div[4]/span");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]/ul/li");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoSalvarEProximo = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoSalvarAlteracoes = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoCancelar = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-left\"]");

    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");

    By embPanela = By.xpath("//div[@id=\"grid-10121668802324194575642\"]//span[text() = 'PANELA']");
    By checkBoxPrato = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[1]");
    By codigoPrato = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[2]/span");
    By nomePrato = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[3]/span");
    By unidadePrato = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[4]/span");
    By quantidadePrato = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[1]/div[5]/span");

    By checkBoxPrato2 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[2]/div[1]");
    By codigoPrato2 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[2]/div[2]/span");
    By nomePrato2 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[2]/div[3]/span");
    By unidadePrato2 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[2]/div[4]/span");
    By quantidadePrato2 = By.xpath("//div[@id=\"grid-10121668804161559854644\"]//div[@class=\"body-content\"]/div[2]/div[5]/span");

    By campoPrato = By.id("NMPRATO");
    By botaoCampoPrato = By.xpath("//div[@id=\"NMPRATO\"]//span[@style=\"background-image: none; display: block;\"]");
    By pratoTortaChocolate = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'TORTA DE CHOCOLATE']");
    By campoQuantPrato = By.id("VRQTDEPRATEMB");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button");
    By botaoSim = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-zh-id=\"zh-footer-alert-button-0\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Relação Prato x Embalagem");
        click(opcaoTelaRelacaoPratoXEmbalagem);
    }

    public void adicionarEmbalagemPrato() {
        click(abaEmbalagemPorPrato);
        click(pratoFeijoadaTransportada);
        click(botaoAdicionar);
        clicarCampoSelecionarValor(botaoCampoEmbalagem, embalagemPanela);
        sendKeys(campoQuantidade, "8,5");
        click(botaoSalvarEProximo);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem apresentada no canto superior direiro após adicionar uma embalagem ao prato");
        click(botaoCancelar);
    }

    public void verificarEmbalagem() {
        //valores encontrados
        String encCodigo = getText(codigoEmbalagem);
        String encNome = getText(nomeEmbalagem);
        String encQuantidade = getText(quantidadeEmbalagem);

        String expCodigo = "00008";
        String expNome = "PANELA";
        String expQuantidade = "8,50000";
        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código da embalagem adicionada");
        Assert.assertEquals(encNome, expNome, "Verificação do nome da embalagem adicionada");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação da quantidade da embalagem adicionada");
        click(botaoVoltar);
    }

    public void verificarEmbalagemAddNaAbaPratoEmbalagem() {
        click(abaPratoPorEmbalagem);
        click(embPanela);

        //valores encontrados
        String encCodigoPrato = getText(codigoPrato);
        String encNomePrato = getText(nomePrato);
        String encUnidadePrato = getText(unidadePrato);
        String encQuantidadePrato = getText(quantidadePrato);

        //valores esperados
        String expCodigoPrato = "00.01.00.001";
        String expNomePrato = "FEIJOADA TRANSPORTADA";
        String expUnidadePrato = "KG";
        String expQuantidadePrato = "8,50000";

        Assert.assertEquals(encCodigoPrato, expCodigoPrato, "Verificação do código do prato adicionado");
        Assert.assertEquals(encNomePrato, expNomePrato, "Verificação do nome do prato adicionado");
        Assert.assertEquals(encUnidadePrato, expUnidadePrato, "Verificação da unidade do prato adicionado");
        Assert.assertEquals(encQuantidadePrato, expQuantidadePrato, "Verificação da quantidade do prato adicionado");

    }

    public void alterarQuantidadePrato() {
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(quantidadePrato)).click().build().perform();
        tempo();
        actions.sendKeys("7").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        click(botaoSalvarAlteracoes);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem que é exibida no canto superior direito, após salvar as alterações");

        String quantidade = getText(quantidadePrato);
        String expQuantidade = "7,00000";
        Assert.assertEquals(quantidade,expQuantidade, "Verificação da quantidade do prato, após a mesma ser alterada");
    }

    public void verificarAlteracaoDaQuantNaAbaEmbPorPrat() {
        click(abaEmbalagemPorPrato);
        click(pratoFeijoadaTransportada);

        String quantidade = getText(quantidadeEmbalagem);
        String expQuantidade = "7,00000";
        Assert.assertEquals(quantidade, expQuantidade, "Verificação do valor da quantidade na aba Emabalagem por Prato, após a edição se realizada na aba Prato por Emabalagem");
    }

    public void adicionarPratoEmbalagem() {
        click(botaoAdicionar);
        click(botaoCampoPrato);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-9000 > div.grid-vertical-scroll-control\").scrollBy(0, 200)");
        click(pratoTortaChocolate);
        sendKeys(campoQuantPrato, "5");
        click(botaoSalvarEProximo);
        click(botaoCancelar);
    }

    public void verificarSegundoPratoAddAbaPratoEmbalagem() {
        //valores encontrados
        String encCodigo = getText(codigoPrato2);
        String encNome = getText(nomePrato2);
        String encUnidade = getText(unidadePrato2);
        String encQuant = getText(quantidadePrato2);

        //valores esperados
        String expCodigo = "01.00.01.000";
        String expNome = "TORTA DE CHOCOLATE";
        String expUnidade = "BG";
        String expQuant = "5,00000";

        Assert.assertEquals(encCodigo, expCodigo, "Verificação do código do segundo prato adicionado na aba Prato por Emabalagem");
        Assert.assertEquals(encNome, expNome, "Verificação do nome do segundo prato adicionado na aba Prato por Emabalagem");
        Assert.assertEquals(encUnidade, expUnidade, "Verificação da unidade do segundo prato adicionado na aba Prato por Emabalagem");
        Assert.assertEquals(encQuant, expQuant, "Verificação da quantidade do segundo prato adicionado na aba Prato por Emabalagem");
        click(botaoVoltar);
    }

    public void verificarSegundaEmbalagemAddAbaEmbalagemPrato() {
        click(abaEmbalagemPorPrato);
        click(tortaDeChocolate);

        //valores encontrados
        String encEmbalagem = getText(nomeEmbalagem);
        String encQuantidade = getText(quantidadeEmbalagem);

        //valores esperados
        String expEmabalagem = "PANELA";
        String expQuantidade = "5,00000";
        Assert.assertEquals(encEmbalagem, expEmabalagem, "Verificação do nome segunda embalagem adiconada na aba Embalagem por Prato");
        Assert.assertEquals(encQuantidade, expQuantidade, "Verificação da quantidade da segunda embalagem adiconada na aba Embalagem por Prato");
    }

    public void alterarQuantDaSegundaEmbAdd() {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(quantidadeEmbalagem)).click().build().perform();
        tempo();
        actions.sendKeys("3").build().perform();
        tempo();
        actions.sendKeys(Keys.ENTER).build().perform();
        click(botaoSalvarAlteracoes);
        tempo();

        String encQuant = getText(quantidadeEmbalagem);
        String expQuant = "3,00000";
        Assert.assertEquals(encQuant, expQuant, "Verificação da quantidade após a alteração da mesma");
        click(botaoVoltar);
    }

    public void removerEmbalagemPratoFeijada() {
        click(checkBoxEmabalagem);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem dexibida na tela após clicar no botão excluir");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida no canto superior direito, após excluir a embalagem do prato");
        click(botaoVoltar);
    }

    public void verificarAlteracaoQuantSegEmbAbaPratoEmbalagem() {
        click(abaPratoPorEmbalagem);
        click(embPanela);

        String encQuant = getText(quantidadePrato2);
        String expQuant = "3,00000";
        Assert.assertEquals(encQuant, expQuant, "Verificar se o valor da quantidade também, também foi alterada na tela da embalagem");
        click(botaoVoltar);
    }

    public void removerPratoTortaChocolate() {
        click(abaPratoPorEmbalagem);
        click(embPanela);
        click(checkBoxPrato);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem dexibida na tela após clicar no botão excluir");
        click(botaoSim);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificação da mensagem exibida no canto superior direito, após excluir a embalagem do prato");
        click(botaoVoltar);
    }

    public void tentarAddEmbalagemJaAddAoPratoFeijoadaTransportada() {
        click(botaoAdicionar);
        clicarCampoSelecionarValor(botaoCampoEmbalagem, embalagemPanela);
        sendKeys(campoQuantidade, "6");
        click(botaoSalvarEProximo);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem que é exibida quando tenta adicionar uma embalagem que o prato já possui");
        click(botaoOk);

        click(botaoCampoEmbalagem);
        click(botaoCampoEmbalagem);
        click(embalagemMarmitex);
        click(botaoSalvarEProximo);
        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem que é exibida no canto superior direito após adicionar uma embalagem em um prato");

        click(botaoCancelar);

        String encEmbalagem = getText(nomeEmbalagem);
        String encQuant = getText(quantidadeEmbalagem);

        String expEmbalagem = "MARMITÉX";
        String expQuant = "6,00000";
        Assert.assertEquals(encEmbalagem, expEmbalagem, "Verificar nome da segunda embalagem adicionada");
        Assert.assertEquals(encQuant, expQuant, "Verificar valor da quantidade da segunda embalagem adicionada");

        excluirEmbalagem();
        excluirEmbalagem();
        click(botaoVoltar);
    }

    private void excluirEmbalagem() {
        tempo();
        click(checkBoxEmabalagem);
        click(botaoExcluir);
        click(botaoSim);
    }

    public void addPratoTortaChocolatePratoEmbalagem() {
        click(abaPratoPorEmbalagem);
        click(embPanela);
        addTortaChocolate();
        click(botaoCancelar);
        addTortaChocolate();

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um prato que já está adicionado em uma embalagem");
        click(botaoOk);
        click(botaoCancelar);
        click(checkBoxPrato);
        click(botaoExcluir);
        click(botaoSim);
    }

    private void addTortaChocolate() {
        click(botaoAdicionar);
        click(botaoCampoPrato);
        javaScriptExecutor.executeScript("document.querySelector(\"#grid-9000 > div.grid-vertical-scroll-control\").scrollBy(0, 200)");
        tempo();
        click(pratoTortaChocolate);
        sendKeys(campoQuantPrato, "5");
        click(botaoSalvarEProximo);
    }

}
