package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.HistoricoAjusteCardapioFlows;
import com.javaseleniumtemplate.pages.HistoricoAjusteCardapioPage;
import org.testng.annotations.Test;

public class HistoricoAjusteCardapioTests extends TestBase {

    HistoricoAjusteCardapioPage historicoAjusteCardapioPage;
    HistoricoAjusteCardapioFlows historicoAjusteCardapioFlows;
    LoginFlows loginFlows;

    @Test
    public void relatorioHistoricoAjusteCardapio() {
        emitiRelatorio("Histórico Ajuste de Cardápio");
    }

    @Test
    public void relatorioAderenciaPercentual() {
        emitiRelatorio("Aderência de Cardápio (Percentual)");
    }

    @Test
    public void relatorioAderenciaTipoPratoPercentual() {
        emitiRelatorio("Aderência de Cardápio por Tipo de Prato (Percentual)");
    }

    @Test
    public void relatorioAlteracaoCardapio() {
        emitiRelatorio("Alterações do Cardápio");
    }

    @Test
    public void relatorioLogAlteracoes() {
        emitiRelatorio("Log de Alterações no Cardápio");
    }

    public void emitiRelatorio(String nomeRelatorio) {
        historicoAjusteCardapioPage = new HistoricoAjusteCardapioPage();
        historicoAjusteCardapioFlows = new HistoricoAjusteCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        historicoAjusteCardapioFlows.navegateTelaHistoricoAjusteCardapio();
        historicoAjusteCardapioPage.selecionarRelatorio(nomeRelatorio);
        historicoAjusteCardapioPage.selecionarTodasUnidades();
        historicoAjusteCardapioPage.geraRelatorio();
        historicoAjusteCardapioPage.selecionarUnidades();
        historicoAjusteCardapioPage.selecionarServicos();
        historicoAjusteCardapioPage.selecionarTipoPrato();
        historicoAjusteCardapioPage.geraRelatorio();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

    //verificação dos campos obrigatórios
    //verificar se o campo 'Percentual Mínimo de Ajustes' está sendo preenchido corretamente
    @Test
    public void verificandoComponentes() {
        historicoAjusteCardapioPage = new HistoricoAjusteCardapioPage();
        historicoAjusteCardapioFlows = new HistoricoAjusteCardapioFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        historicoAjusteCardapioFlows.navegateTelaHistoricoAjusteCardapio();
        historicoAjusteCardapioPage.campoObrigatorios();
        historicoAjusteCardapioPage.preencherPercentualMinimo();

        try {
            Thread.sleep(8000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }

}
